package com.example.tfat.myapplication

import android.app.Activity
import android.app.AlertDialog
import android.app.ProgressDialog
import android.content.Context
import android.content.DialogInterface
import android.content.Intent
import android.graphics.Bitmap
import android.graphics.BitmapFactory
import android.graphics.Canvas
import android.net.Uri
import android.os.Bundle
import android.provider.MediaStore
import android.support.v7.app.AppCompatActivity
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.support.v7.widget.helper.ItemTouchHelper
import android.util.DisplayMetrics
import android.view.*
import android.widget.PopupWindow
import android.widget.SeekBar
import com.bomostory.sceneeditmodule.*
import com.bomostory.sceneeditmodule.basicdata.*
import com.bomostory.sceneeditmodule.navigationbar.actor.SelectActorView
import com.bomostory.sceneeditmodule.navigationbar.brush.BrushView
import com.bomostory.sceneeditmodule.navigationbar.dialogue.DialogueView
import com.bomostory.sceneeditmodule.screen.movie.MovieEditActivity
import com.bomostory.sceneeditmodule.utils.FileUtils
import com.example.tfat.myapplication.navigationbar.NavigationBarView
import com.example.tfat.myapplication.navigationbar.RecordFinishView
import com.example.tfat.myapplication.navigationbar.actor.ActorAdapter
import com.example.tfat.myapplication.navigationbar.actor.LayerManagementDialog
import com.google.gson.Gson
import kotlinx.android.synthetic.main.activity_scene_edit.*
import kotlinx.android.synthetic.main.control_actor_dialog.view.*
import android.widget.RadioGroup
import com.bomostory.sceneeditmodule.EditTextDialog
import kotlinx.android.synthetic.main.popupview_opacity_dialog.view.*
import kotlinx.android.synthetic.main.view_control_dialogue_dialog.view.*
import com.bomostory.sceneeditmodule.DialogueColorData
import com.bomostory.sceneeditmodule.SceneDrawer
import com.bomostory.sceneeditmodule.cover.CoverEditorDialog
import com.bomostory.sceneeditmodule.layermanagement.ItemTouchHelpCallback
import com.bomostory.sceneeditmodule.navigationbar.actor.ObjectView
import com.bomostory.sceneeditmodule.navigationbar.actor.NonInterceptTouchRecycleView
import com.bomostory.sceneeditmodule.screen.draw.DrawActivity
import com.bomostory.sceneeditmodule.screen.view.*
import com.example.tfat.myapplication.navigationbar.scene.*
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import kotlinx.android.synthetic.main.actor_select_view.view.*
import kotlinx.android.synthetic.main.add_scene_view.view.*
import kotlinx.android.synthetic.main.layer_management_fragment.*
import kotlinx.android.synthetic.main.navigation_bar_view.view.*
import kotlinx.android.synthetic.main.popupview_adjustment_dialog.view.*
import kotlinx.android.synthetic.main.popupview_color_dialog.view.*
import kotlinx.android.synthetic.main.popupview_setting.view.*
import kotlinx.android.synthetic.main.popupview_start_over.view.*
import kotlinx.android.synthetic.main.replace_scene_view.view.*
import kotlinx.android.synthetic.main.scene_control_view.view.*
import java.io.ByteArrayOutputStream
import java.io.File
import java.util.*
import java.util.concurrent.CopyOnWriteArrayList
import kotlin.collections.ArrayList


class SceneEditActivity : AppCompatActivity(), ActorAdapter.OnActorDragListener, EditActorView.OnActorChangeListener,
        OnTouchBoMoSceneListener.OnSceneMoveListener, DialogInterface.OnDismissListener, FileUtils.OnSaveActorImage,
        OnTouchSceneListener.OnSceneTouchListener,LayerManagementDialog.OnLayerChange, EditTextDialog.OnSetDialogFinish,
        BrushView.OnSelectBrush, FileUtils.OnSaveCover, FileUtils.OnSaveThemeImage, SceneAdapter.ItemMoveListener {

    private lateinit var project: Project
    private var currentSceneIndex = 0
    private var currentLayerIndex = 6
    private var startRecordTime = 0L
    private var recordingTime = 0L
    private var swipeX = 0
    private var record = Record()
    private var resourceThemeBitmap = ArrayList<String>()
    private var resourceActorBitmap = ArrayList<ArrayList<String>>()
    private var resourceObjectPath = ArrayList<String>()
    private var themeName = ""
    private lateinit var sceneAdapter: SceneAdapter
    private var isRecord = false
    private var isAutoSwipe = false
    private var isClearObjects = false
    private var layerManagementDialog = LayerManagementDialog()
    private var editTextDialog = EditTextDialog()
    private val monitorSize = DisplayMetrics()
    private var timer = Timer()
    private val audioRecorder = AudioRecorder()
    companion object {
        const val PHOTO_FROM_GALLERY = 1
        const val ACTOR_FROM_BRUSH = 2
        const val FROM_GALLERY_AND_CROP = 3
        const val CROP_TO_BACKGROUND = 4
        const val LAYER_MANAGEMENT = "layer_management"
        const val ACTOR_HEIGHT = 400
        const val ACTOR_WIDTH = 400
        const val DIALOGUE_HEIGHT = 320
        const val DIALOGUE_WIDTH = 400
        const val ACTOR_INIT_POSITION_X = 200
        const val ACTOR_INIT_POSITION_Y = 200
        const val BACKGROUND_MOVE_RATE = 32
        const val TIME_STEP_FOR_FPS = 33L
        val listeners = CopyOnWriteArrayList<Runnable>()
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_scene_edit)
        window.setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
                WindowManager.LayoutParams.FLAG_FULLSCREEN)
        actionBar?.hide()
        supportActionBar?.hide()
        windowManager.defaultDisplay.getMetrics(monitorSize)
        project = Gson().fromJson<Project>(intent.getStringExtra("project"), Project::class.java)
        initResource()
        var layoutPrams = sceneEditView.layoutParams
        layoutPrams.width = monitorSize.widthPixels
        layoutPrams.height = monitorSize.widthPixels.div(2)
        sceneEditView.layoutParams = layoutPrams
        project.story?.let {
            it.scenes?.let{
                for (i in 0 until it.size) {
                    it[i].sceneWidth = monitorSize.widthPixels
                }
                if (project.coverFile == null) {
                    val bitmap = CoverDrawer.drawFrontCover((monitorSize.widthPixels) / 2, monitorSize.heightPixels, project.displayName
                            ?: "", project.author ?: "", project.frontCoverColor.getColor(this))
                    val bitmap2 = CoverDrawer.drawBackCover(this, (monitorSize.widthPixels) / 2, monitorSize.heightPixels, project.backCoverColor.getColor(this))
                    val bitmap3 = Bitmap.createBitmap(monitorSize.widthPixels, monitorSize.heightPixels, bitmap.config)
                    val canvas = Canvas(bitmap3)
                    canvas.drawBitmap(bitmap, 0f, 0f, null)
                    canvas.drawBitmap(bitmap2, ((monitorSize.widthPixels) / 2).toFloat(), 0f, null)
                    FileUtils.saveCover(this, project, bitmap3, project.name.toString())
                } else {
                    sceneEditView.scene = it[0]
                }
            }
        }
        ic_scene_edit_activity_back.setOnClickListener {
            val pd = ProgressDialog(this).apply {
                setCancelable(false)
            }
            FileUtils.saveProject(this, project, 1920,1080)
                    .subscribeOn(Schedulers.io())
                    .observeOn(AndroidSchedulers.mainThread())
                    .doOnSubscribe { pd.show() }
                    .doFinally {
                        pd.dismiss()
                        window.decorView.apply {
                            systemUiVisibility = (View.SYSTEM_UI_FLAG_LAYOUT_STABLE
                                    or View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION
                                    or View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN
                                    or View.SYSTEM_UI_FLAG_HIDE_NAVIGATION
                                    or View.SYSTEM_UI_FLAG_FULLSCREEN
                                    or View.SYSTEM_UI_FLAG_LOW_PROFILE
                                    or View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY)
                        }
                        this.onBackPressed()}
                    .subscribe {
                        listeners.forEach {it.run()}
                    }
        }
        initExportVideoButton()
        initPreviousNextButton()
        initControlBarView()
        project.story?.let {
            it.scenes?.let {
                when (it[0].record) {
                    null -> {
                        initNavigationFunction()
                    }
                    else -> {
                        initNavigationBarView(0)
                    }
                }
            }
        }
        initRecord()
        initCurrentState()
    }

    override fun onResume() {
        super.onResume()
        hideStatusBar()
    }

    private fun hideStatusBar(){
        window.decorView.apply {
            systemUiVisibility = (View.SYSTEM_UI_FLAG_LAYOUT_STABLE
                    or View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION
                    or View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN
                    or View.SYSTEM_UI_FLAG_HIDE_NAVIGATION
                    or View.SYSTEM_UI_FLAG_FULLSCREEN
                    or View.SYSTEM_UI_FLAG_LOW_PROFILE
                    or View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY)
        }
    }
    private fun initResource(){
        resourceThemeBitmap = when(intent.getStringExtra("resource_actor")) {
            null -> {
                ArrayList<String>().apply {
                    project.themeAssetIndex.contains.scene.values.forEach {
                        val path = "${project.assetFolder.path}/${it.largeFile}"
                        add(path)
                    }
                }
            }
            else -> {
                intent.getStringArrayListExtra("resource_scene")
            }
        }
        if (!resourceThemeBitmap.contains(File(Config.ASSETS_FOLDER, Config.PROJECT_WHITE_FILE_NAME).path)){
            resourceThemeBitmap.add(File(Config.ASSETS_FOLDER, Config.PROJECT_WHITE_FILE_NAME).path)
        }
        resourceActorBitmap = when(intent.getStringExtra("resource_actor")) {
            null -> {
                ArrayList<ArrayList<String>>().apply {
                    project.themeAssetIndex.contains.actor.forEach {
                        add(ArrayList<String>().apply {
                            it.value.values.forEach {
                                val path = "${project.assetFolder.path}/${it.largeFile}"
                                add(path)
                            }
                        })
                    }
                }
            }
            else -> { Gson().fromJson<ThemeActorResource>(intent.getStringExtra("resource_actor"), ThemeActorResource::class.java).actorPath}
        }
        resourceObjectPath = when(intent.getStringArrayListExtra("resource_object")) {
            null -> {
                ArrayList<String>().apply {
                    project.themeAssetIndex.contains.obj.values.forEach {
                        val path = "${project.assetFolder.path}/${it.largeFile}"
                        add(path)
                    }
                }
            }
            else -> { intent.getStringArrayListExtra("resource_object")}
        }
        themeName = project.themeAssetIndex.name
    }

    private fun initCurrentState(){
        val currentScene =  intent.getIntExtra("currentScene",0)
        val currentLayer = intent.getIntExtra("currentLayer",6)
        var oldSceneIndex = currentSceneIndex
        currentSceneIndex = currentScene
        switchToPreViewLayer()
        project.story?.let {
            it.scenes?.let{
                sceneEditView.scene = it[currentScene]
            }
        }
        record = Record()
        initControlBarView()
        initNavigationBarView(oldSceneIndex)
        initPreviousNextButton()
        switchLayer(currentLayer)
        if(intent.getBooleanExtra("is_from_choose_theme",false)) {
            themeName = intent.getStringExtra("theme_name")
            initActorRecyclerView()
        }
    }
    private fun initControlBarView() {
        controlBarView.setBtnSelected(6)
        switchToPreViewLayer()
        project.story?.let {
            it.scenes?.let {
                if (it[currentSceneIndex].record != null || currentSceneIndex == 0) {
                    controlBarView.visibility = View.INVISIBLE
                    sceneEditView.setOnTouchListener(null)
                } else {
                    controlBarView.visibility = View.VISIBLE
                }
            }
        }
        controlBarView.setonClickSwipeLayerBtn(View.OnClickListener {
            switchToPreViewLayer()
        })
        controlBarView.setonClickLayerSceneBtn(View.OnClickListener {
            controlBarView.setBtnSelected(5)
            layerManagementDialog = LayerManagementDialog()
            project.story?.let {
                it.scenes?.let{
                    layerManagementDialog.setData(it[currentSceneIndex])
                }
            }
            layerManagementDialog.setListener(this)
            layerManagementDialog.show(supportFragmentManager,LAYER_MANAGEMENT)
        })
        controlBarView.setonClickLayerBackgroundBtn(View.OnClickListener {
            switchLayer(4)
        })
        controlBarView.setonClickLayer4Btn(View.OnClickListener {
            switchLayer(3)
        })
        controlBarView.setonClickLayer3Btn(View.OnClickListener {
            switchLayer(2)
        })
        controlBarView.setonClickLayer2Btn(View.OnClickListener {
            switchLayer(1)
        })
        controlBarView.setonClickLayer1Btn(View.OnClickListener {
            switchLayer(0)
        })
    }

    private fun initNavigationBarView(position: Int) {
        initNavigationFunction()
    }

    private fun initNavigationFunction(){
        var navigationBarView = NavigationBarView(this)
        project.story?.let {
            it.scenes?.let {
                if(currentSceneIndex == 0){
                    when (it[currentSceneIndex].record) {
                        null -> {
                            startRecord.setImageDrawable(resources.getDrawable(R.drawable.ic_btn_record))
                            navigationBarView.setBtnDisable()
                            navigationBar.addView (navigationBarView)
                            navigationBarView.setonClickSceneBtn (View.OnClickListener {
                                initControlSceneView()
                            })
                            navigationBarView . setonClickActorBtn (View.OnClickListener {})
                            navigationBarView . setonClickBrushBtn (View.OnClickListener {})
                            navigationBarView . setonClickDialogueBtn (View.OnClickListener {})
                            navigationBarView . setonClickImageBtn (View.OnClickListener {})
                            navigationBarView . setonClickSettingBtn (View.OnClickListener {})
                        }
                        else -> {
                            startRecord.setImageDrawable(resources.getDrawable(R.drawable.ic_btn_startover))
                            navigationBarView.setBtnDisable()
                            navigationBar.addView(navigationBarView)
                            navigationBarView.setonClickSceneBtn (View.OnClickListener {
                                initControlSceneView()
                            })
                            navigationBarView . setonClickActorBtn (View.OnClickListener {})
                            navigationBarView . setonClickBrushBtn (View.OnClickListener {})
                            navigationBarView . setonClickDialogueBtn (View.OnClickListener {})
                            navigationBarView . setonClickImageBtn (View.OnClickListener {})
                            navigationBarView . setonClickSettingBtn (View.OnClickListener {})
                        }
                    }
                } else {
                    when (it[currentSceneIndex].record) {
                        null -> {
                            startRecord.setImageDrawable(resources.getDrawable(R.drawable.ic_btn_record))
                            navigationBarView.setBtnEnable()
                            navigationBar.addView(navigationBarView)
                            navigationBarView.setonClickSceneBtn(View.OnClickListener {
                                initControlSceneView()
                            })
                            navigationBarView.setonClickActorBtn(View.OnClickListener {
                                initActorRecyclerView()
                            })
                            navigationBarView.setonClickBrushBtn(View.OnClickListener {
                                initBrushView()
                            })
                            navigationBarView.setonClickDialogueBtn(View.OnClickListener {
                                initDialogueView()
                            })
                            navigationBarView.setonClickImageBtn(View.OnClickListener {
                                pickFromGallery()
                            })
                            navigationBarView.setonClickSettingBtn(View.OnClickListener {
                                var popupWindow = PopupWindow(this)
                                popupWindow.contentView = createSettingPopupView()
                                popupWindow.width = ViewGroup.LayoutParams.WRAP_CONTENT
                                popupWindow.height = ViewGroup.LayoutParams.WRAP_CONTENT
                                popupWindow.isOutsideTouchable = true
                                var valueXInPixels = resources.getDimension(R.dimen.popup_view_setting_height) + resources.getDimension(R.dimen.navigation_bar_height)
                                popupWindow.showAsDropDown(navigationBarView.settings, 0, -(valueXInPixels).toInt(), Gravity.CENTER_HORIZONTAL)

                            })
                        }
                        else -> {
                            startRecord.setImageDrawable(resources.getDrawable(R.drawable.ic_btn_startover))
                            navigationBarView.setBtnDisable()
                            navigationBar.addView(navigationBarView)
                            navigationBarView.setonClickSceneBtn(View.OnClickListener {
                                initControlSceneView()
                            })
                            navigationBarView.setonClickActorBtn(View.OnClickListener {})
                            navigationBarView.setonClickBrushBtn(View.OnClickListener {})
                            navigationBarView.setonClickDialogueBtn(View.OnClickListener {})
                            navigationBarView.setonClickImageBtn(View.OnClickListener {})
                            navigationBarView.setonClickSettingBtn(View.OnClickListener {})
                        }
                    }
                }
            }
        }
        initExportVideoButton()
    }

    private fun createSettingPopupView(): View{
        val popupView = LayoutInflater.from(this).inflate(R.layout.popupview_setting, null)
        when (isAutoSwipe) {
            true -> {
                popupView.rb_manual.isChecked  = false
                popupView.rb_auto_swipe.isChecked = true
            }
            false -> {
                popupView.rb_manual.isChecked  = true
                popupView.rb_auto_swipe.isChecked = false
            }
        }

        popupView.rg_settings.setOnCheckedChangeListener(object : RadioGroup.OnCheckedChangeListener{
            override fun onCheckedChanged(group: RadioGroup?, checkedId: Int) {
                when (checkedId) {
                    popupView.rb_manual.id -> {
                        isAutoSwipe = false
                    }
                    popupView.rb_auto_swipe.id ->{
                        isAutoSwipe = true
                    }
                }
            }
        })
        return popupView
    }

    private fun createStartOverPopupView(): View{
        val popupView = LayoutInflater.from(this).inflate(R.layout.popupview_start_over, null)
        when (isClearObjects) {
            true -> {
                popupView.rb_keep.isChecked  = false
                popupView.rb_clear_all.isChecked = true
            }
            false -> {
                popupView.rb_keep.isChecked  = true
                popupView.rb_clear_all.isChecked = false
            }
        }
        popupView.rg_start_over_settings.setOnCheckedChangeListener(object : RadioGroup.OnCheckedChangeListener{
            override fun onCheckedChanged(group: RadioGroup?, checkedId: Int) {
                when (checkedId) {
                    popupView.rb_keep.id -> {
                        isClearObjects = false
                    }
                    popupView.rb_clear_all.id ->{
                        isClearObjects = true
                    }
                }
            }
        })
        return popupView
    }

    private fun initBrushView(){
        if (currentLayerIndex == 6){
            switchLayer(0)
            initBrushView()
        } else {
            unSelectActor()
            var intent = Intent(this, DrawActivity::class.java).apply {
                putExtra("project", Gson().toJson(project))
                putExtra("currentScene", currentSceneIndex)
            }
            startActivityForResult(intent, ACTOR_FROM_BRUSH)
        }
    }

    private fun initActorRecyclerView() {
        if (viewContainer.getChildAt(0) is SelectActorView || viewContainer.getChildAt(0) is ObjectView || viewContainer.getChildAt(0) is AddSceneView) {
            viewContainer.removeAllViews()
            startRecord.visibility = View.VISIBLE
            initPreviousNextButton()
            return
        } else {
            viewContainer.removeAllViews()
        }
        startRecord.visibility = View.INVISIBLE
        if (currentLayerIndex == 6) {
            switchLayer(0)
            initActorRecyclerView()
        }
        var selectActorView = SelectActorView(this)
        val layoutManager = LinearLayoutManager(this)
        layoutManager.orientation = LinearLayoutManager.HORIZONTAL
        var actorAdapter = ActorAdapter(this, resourceActorBitmap, sceneEditView.findViewById(currentLayerIndex), this)
        var actorRecyclerView = selectActorView.findViewById<NonInterceptTouchRecycleView>(R.id.select_actor_recycler_view)
        actorRecyclerView.layoutManager = layoutManager
        actorRecyclerView.adapter = actorAdapter
        viewContainer.addView(selectActorView)
        selectActorView.layoutParams.width = monitorSize.widthPixels
        selectActorView.btn_object.setOnClickListener {
            initAddObjectView()
        }
        selectActorView.btn_scene.setOnClickListener {
            initReplaceSceneView()
        }
        selectActorView.btn_choose_theme.text = themeName
        selectActorView.btn_choose_theme.setOnClickListener {
            chooseTheme()
        }
        initPreviousNextButton()
    }
    private fun initDialogueView(){
        if (viewContainer.getChildAt(0) is DialogueView) {
            viewContainer.removeAllViews()
            startRecord.visibility = View.VISIBLE
            initPreviousNextButton()
            return
        } else {
            viewContainer.removeAllViews()
        }
        startRecord.visibility = View.INVISIBLE
        if (currentLayerIndex == 6){
            switchLayer(0)
            initDialogueView()
            return
        }
        var dialogueView = DialogueView(this)
        sceneEditView.findViewById<LayerView>(currentLayerIndex).setOnDragListener(dragListener())
        viewContainer.addView(dialogueView)
        dialogueView.layoutParams.width = monitorSize.widthPixels
        initPreviousNextButton()
    }


    private fun initControlSceneView() {
        if (viewContainer.getChildAt(0) is ControlSceneView) {
            viewContainer.removeAllViews()
            initPreviousNextButton()
            return
        }
        setControlSceneView()
        initPreviousNextButton()
    }

    private fun setControlSceneView(){
        var projectBitmaps = ArrayList<Bitmap?>()
        var onSceneSelectedArrayList = ArrayList<View.OnClickListener>()
        var recordTimeArrayList = ArrayList<Long?>()
        project.story?.let {
            it.scenes?.let{
                for (i in 0 until it.size) {
                    onSceneSelectedArrayList.add(switchScene(i))
                    projectBitmaps.add(SceneDrawer.drawScene(this,it[i],0,200,100))
                    recordTimeArrayList.add(it[i].record?.period)
                }
            }
        }
        sceneAdapter = SceneAdapter(this, projectBitmaps, onSceneSelectedArrayList, currentSceneIndex, recordTimeArrayList)
        sceneAdapter.listener = this@SceneEditActivity
        var controlSceneView = ControlSceneView(this)
        controlSceneView.setonClickAddBtn(View.OnClickListener {
            viewContainer.removeAllViews()
            var replaceSceneView = ReplaceSceneView(this)
            viewContainer.addView(replaceSceneView)
            val layoutManager = LinearLayoutManager(this)
            layoutManager.orientation = LinearLayoutManager.HORIZONTAL
            var onSceneSelectedArrayList = ArrayList<View.OnClickListener>()
            for (i in 0 until resourceThemeBitmap.size) {
                onSceneSelectedArrayList.add(onClickAddSceneListener(i))
            }
            var replaceSceneAdapter = ReplaceSceneAdapter(this, resourceThemeBitmap, onSceneSelectedArrayList)
            var newSceneRecyclerView = replaceSceneView.findViewById<RecyclerView>(R.id.new_scene_recycler_view)
            newSceneRecyclerView.layoutManager = layoutManager
            newSceneRecyclerView.adapter = replaceSceneAdapter
            replaceSceneView.btn_add_scene_view_choose_theme.text = themeName
            replaceSceneView.btn_add_scene_view_choose_theme.setOnClickListener {
                chooseTheme()
            }
        })
        when (currentSceneIndex) {
            0 -> {
                controlSceneView.btn_controlSceneView_duplicate.text = resources.getString(R.string.uikit_home_edit_cover)
                controlSceneView.setonClickDuplicateBtn(View.OnClickListener {
                    onClickEditCover(project)
                })
            }

            else -> {
                controlSceneView.btn_controlSceneView_duplicate.text = resources.getString(R.string.uikit_edit_duplicate)
                controlSceneView.setonClickDuplicateBtn(View.OnClickListener {
                    project.story?.let {
                        it.scenes?.let {
                            var scene = Scene().apply {
                                backgroundName = it[currentSceneIndex].backgroundName
                                backgroundPath = it[currentSceneIndex].backgroundPath
                                record = it[currentSceneIndex].record
                                sceneWidth = it[currentSceneIndex].sceneWidth
                                recordPath = it[currentSceneIndex].recordPath
                                for (layer in it[currentSceneIndex].layers) {
                                    var newLayer = Layer()
                                    newLayer.id = layer.id
                                    newLayer.name = layer.name
                                    for(actor in layer.actors) {
                                        var newActor = Actor()
                                        newActor.resourcePath = actor.resourcePath
                                        newActor.positionX = actor.positionX
                                        newActor.positionY = actor.positionY
                                        newActor.positionZ = actor.positionZ
                                        newActor.sideLength = actor.sideLength
                                        newActor.sideHeight = actor.sideHeight
                                        newActor.isSelect = actor.isSelect
                                        newActor.parentLayerIndex = actor.parentLayerIndex
                                        newActor.isMovable = actor.isMovable
                                        newActor.text = actor.text
                                        newActor.textColor = actor.textColor
                                        newActor.textAlign = actor.textAlign
                                        newActor.isDialogue = actor.isDialogue
                                        newActor.isMirror = actor.isMirror
                                        newActor.opacity = actor.opacity
                                        newActor.dialogColor = actor.dialogColor
                                        newActor.dialogType = actor.dialogType
                                        newActor.hue = actor.hue
                                        newActor.saturation = actor.saturation
                                        newActor.brightness = actor.brightness
                                        newLayer.actors.add(newActor)
                                    }
                                    layers[it[currentSceneIndex].layers.indexOf(layer)] = newLayer
                                }
                            }
                            it.add(currentSceneIndex + 1, scene)
                        }
                    }
                    var sceneAdapter = controlSceneView.findViewById<RecyclerView>(R.id.scene_recycler_view).adapter as SceneAdapter
                    var projectBitmaps = ArrayList<Bitmap?>()
                    var onSceneSelectedArrayList = ArrayList<View.OnClickListener>()
                    project.story?.let {
                        it.scenes?.let{
                            for (i in 0 until it.size) {
                                onSceneSelectedArrayList.add(switchScene(i))
                                projectBitmaps.add(SceneDrawer.drawScene(this,it[i],0,200,100))
                                recordTimeArrayList.add(it[i].record?.period)
                            }
                        }
                    }
                    sceneAdapter.update(projectBitmaps, onSceneSelectedArrayList,recordTimeArrayList)
                })
            }
        }

        controlSceneView.setOnClickDeleteBtn(View.OnClickListener {
            var builder = AlertDialog.Builder(this@SceneEditActivity).apply {
                setTitle(resources.getString(R.string.delete_check))
                setPositiveButton(R.string.uikit_others_yes) { dialog, whichButton ->
                    project.story?.let {
                        it.scenes?.let{
                            if (it.size <= 1) { return@let }
                            it.removeAt(currentSceneIndex)
                            when(currentSceneIndex >= it.size){
                                true -> {
                                    currentSceneIndex = 0
                                    sceneEditView.scene = it[0]
                                }
                                false -> sceneEditView.scene = it[currentSceneIndex]
                            }
                            initNavigationBarView(currentSceneIndex)
                            setControlSceneView()
                        }
                    }
                    window.setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
                            WindowManager.LayoutParams.FLAG_FULLSCREEN)
                    actionBar?.hide()
                    supportActionBar?.hide()
                    hideStatusBar()
                }
                setNegativeButton(R.string.uikit_others_not) { dialog, whichButton ->
                    window.setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
                            WindowManager.LayoutParams.FLAG_FULLSCREEN)
                    actionBar?.hide()
                    supportActionBar?.hide()
                    hideStatusBar()
                }
                setOnDismissListener {
                    window.setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
                            WindowManager.LayoutParams.FLAG_FULLSCREEN)
                    actionBar?.hide()
                    supportActionBar?.hide()
                    hideStatusBar()
                }
            }
            val dialog: AlertDialog = builder.create()
            dialog.show()
        })
        val layoutManager = LinearLayoutManager(this)
        layoutManager.orientation = LinearLayoutManager.HORIZONTAL
        var sceneRecyclerView = controlSceneView.findViewById<RecyclerView>(R.id.scene_recycler_view)
        sceneRecyclerView.layoutManager = layoutManager
        sceneRecyclerView.adapter = sceneAdapter
        viewContainer.removeAllViews()
        viewContainer.addView(controlSceneView)
        startRecord.visibility = View.VISIBLE
        var itemTouchHelperCallBack = ItemTouchHelpCallback(sceneAdapter)
        var itemTouchHelper = ItemTouchHelper(itemTouchHelperCallBack)
        itemTouchHelper.attachToRecyclerView(sceneRecyclerView)
    }

    override fun onPause() {
        super.onPause()
        if (isRecord) {
            cancelRecording()
        }
    }

    private fun cancelRecording() {
        audioRecorder.cancelRecording()

        tv_scene_activity_record_time.visibility = View.INVISIBLE
        timer.cancel()
        timer = Timer()
        recordingTime = 0L
        tv_scene_activity_record_time.text = resources.getString(R.string.uikit_edit_recording) + " 00:00"
        isRecord = false
        startRecord.setImageDrawable(resources.getDrawable(R.drawable.ic_btn_startover))
        navigationBar.visibility = View.VISIBLE
        initControlBarView()
        initControlSceneView()
        //initRecordFinishView()
        initExportVideoButton()
    }

    private fun getRecordFilePath(): String {
        return "${FileUtils.getProjectPath(project)}/${Config.RECORD_FOLDER_NAME}/${System.currentTimeMillis()}.mp3"
    }

    private fun initRecord(){
        var recordPath: String? = null
        startRecord.setOnClickListener {
            project.story?.let {
                it.scenes?.let {
                    if (it[currentSceneIndex].record != null) {
                        var popupWindow = PopupWindow(this)
                        var popupView = createStartOverPopupView().apply {
                            tv_popup_start_over_cancel.setOnClickListener {
                                popupWindow.dismiss()
                            }
                            tv_popup_start_over_start_over.setOnClickListener {
                                popupWindow.dismiss()
                                if (!isClearObjects) {
                                    project.story?.let {
                                        it.scenes?.let {
                                            it[currentSceneIndex].record = null
                                            sceneEditView.scene = it[currentSceneIndex]
                                            initNavigationBarView(currentSceneIndex)
                                        }
                                    }
                                } else {
                                    project.story?.let {
                                        it.scenes?.let {
                                            var scene = Scene()
                                            for (i in 5 until 0){
                                                val layer = Layer()
                                                layer.id = i
                                                scene.layers.add(layer)
                                            }
                                            scene.backgroundPath = resourceThemeBitmap[resourceThemeBitmap.size - 1]
                                            scene.sceneWidth = monitorSize.widthPixels
                                            it[currentSceneIndex] = scene
                                            sceneEditView.scene = it[currentSceneIndex]
                                            initNavigationBarView(currentSceneIndex)
                                        }
                                    }
                                }
                            }
                        }

                        popupWindow.contentView = popupView
                        popupWindow.width = resources.getDimension(R.dimen.popup_view_start_over_width).toInt()
                        popupWindow.height = ViewGroup.LayoutParams.WRAP_CONTENT
                        popupWindow.isOutsideTouchable = false
                        var valueYInPixels = resources.getDimension(R.dimen.popup_view_start_over_height) + resources.getDimension(R.dimen.popup_view_start_over_padding_bottom)
                        popupWindow.showAsDropDown(startRecord, -(popupWindow.width / 2), -(valueYInPixels).toInt(), Gravity.CENTER_HORIZONTAL)
                    } else {
                        if (!isRecord) {
                            //  delete record
                            project.story?.let {
                                it.scenes?.let{
                                    if (it[currentSceneIndex].recordPath != null)
                                        File(it[currentSceneIndex].recordPath).delete()
                                    it[currentSceneIndex].record = null
                                }
                            }
                            recordPath = getRecordFilePath()
                            audioRecorder.prepare(File(recordPath))
                            audioRecorder.startRecording()
                            startRecord.setImageDrawable(resources.getDrawable(R.drawable.ic_btn_record_stop))
                            startRecordTime = System.currentTimeMillis()
                            isRecord = true
                            switchToPreViewLayer()
                            navigationBar.visibility = View.INVISIBLE
                            tv_scene_activity_record_time.visibility = View.VISIBLE
                            timer.schedule(object:TimerTask(){
                                override fun run() {
                                    runOnUiThread {
                                        recordingTime ++
                                        tv_scene_activity_record_time.text = "Recording " + "0" + recordingTime.div(60).toString() + ":" +
                                                recordingTime.rem(60).div(10).toString() + recordingTime.rem(60).rem(10).toString()
                                    }
                                }
                            }, 1000, 1000)
                        } else if (recordingTime >= 1){
                            audioRecorder.stopRecording()
                            tv_scene_activity_record_time.visibility = View.INVISIBLE
                            timer.cancel()
                            timer = Timer()
                            recordingTime = 0L
                            tv_scene_activity_record_time.text = resources.getString(R.string.uikit_edit_recording) + " 00:00"
                            isRecord = false
                            record.period = System.currentTimeMillis() - startRecordTime
                            if (!isAutoSwipe){
                                project.story?.let {
                                    it.scenes?.let{
                                        it[currentSceneIndex].record = record
                                        it[currentSceneIndex].recordPath = recordPath
                                    }
                                }
                            } else {
                                var autoSwipeRecord = Record()
                                autoSwipeRecord.period = record.period
                                for (i in 0 until record.period step TIME_STEP_FOR_FPS)
                                    autoSwipeRecord.tracks.apply {
                                        var track = Track().apply {
                                            when (i <= record.period.div(2)){
                                                true -> {
                                                    positionX = (-monitorSize.widthPixels.div(2)) + i.div(TIME_STEP_FOR_FPS).toInt() * monitorSize.widthPixels.div(record.period.div(2 * TIME_STEP_FOR_FPS).toInt())
                                                    time = i
                                                }
                                                false -> {
                                                    var j = i - record.period.div(2)
                                                    positionX = (monitorSize.widthPixels.div(2)) - j.div(TIME_STEP_FOR_FPS).toInt() * monitorSize.widthPixels.div(record.period.div(2 * TIME_STEP_FOR_FPS).toInt())
                                                    time = i
                                                }
                                            }
                                        }
                                        add(track)
                                    }
                                project.story?.let {
                                    it.scenes?.let{
                                        it[currentSceneIndex].record = autoSwipeRecord
                                        it[currentSceneIndex].recordPath = recordPath
                                    }
                                }
                            }

                            startRecord.setImageDrawable(resources.getDrawable(R.drawable.ic_btn_startover))
                            navigationBar.visibility = View.VISIBLE
                            initControlBarView()
                            initControlSceneView()
                            //initRecordFinishView()
                            initExportVideoButton()
                        }
                    }
                }
            }
        }
    }

    private fun initExportVideoButton(){
        var hasRecord = false
        project.story?.let {
            it.scenes?.let {
                it.forEach {
                    if (it.record != null) {
                        hasRecord = true
                    }
                }
            }
        }
        if (hasRecord) {
            btn_scene_edit_activity_export.alpha = 1.0f
            btn_scene_edit_activity_export.setOnClickListener {
                val pd = ProgressDialog(this).apply {
                    setCancelable(false)
                }
                FileUtils.saveProject(this, project, 1920,1080)
                        .subscribeOn(Schedulers.io())
                        .observeOn(AndroidSchedulers.mainThread())
                        .doOnSubscribe { pd.show() }
                        .doFinally { pd.dismiss() }
                        .subscribe {
                            listeners.forEach {it.run()}
                        }
                val intent = Intent(this, MovieEditActivity::class.java)
                intent.putExtra(MovieEditActivity.PROJECT_KEY, Gson().toJson(project))
                startActivity(intent)
            }
        } else {
            btn_scene_edit_activity_export.alpha = 0.4f
            btn_scene_edit_activity_export.setOnClickListener {}
        }

    }

    private fun initPreviousNextButton(){
        when (viewContainer.childCount){
            0 -> {
                previous_page.visibility = View.VISIBLE
                next_page.visibility = View.VISIBLE
            }
            else -> {
                previous_page.visibility = View.INVISIBLE
                next_page.visibility = View.INVISIBLE
            }
        }
        when (currentSceneIndex){
            0 -> {
                previous_page.visibility = View.INVISIBLE
            }
            project.story?.scenes?.size?.minus(1) -> {
                next_page.visibility = View.INVISIBLE
            }
        }
        previous_page.setOnClickListener {
            currentSceneIndex--
            project.story?.let {
                it.scenes?.let{
                    when(currentSceneIndex < 0){
                        true -> {
                            currentSceneIndex = 0
                            sceneEditView.scene = it[currentSceneIndex]
                        }
                        false -> {
                            switchToPreViewLayer()
                            sceneEditView.scene = it[currentSceneIndex]
                        }
                    }
                }
            }
            initControlBarView()
            initPreviousNextButton()
            initNavigationBarView(currentSceneIndex)
        }
        next_page.setOnClickListener {
            currentSceneIndex++
            project.story?.let {
                it.scenes?.let{
                    when(currentSceneIndex < it.size){
                        true -> {
                            switchToPreViewLayer()
                            sceneEditView.scene = it[currentSceneIndex]
                        }
                        false -> {
                            currentSceneIndex = 0
                            sceneEditView.scene = it[currentSceneIndex]
                        }
                    }
                }
            }
            initControlBarView()
            initPreviousNextButton()
            initNavigationBarView(currentSceneIndex)
        }
    }

    private fun initReplaceSceneView(){
        viewContainer.removeAllViews()
        switchLayer(4)
        var addSceneView = AddSceneView(this)
        viewContainer.addView(addSceneView)
        val layoutManager = LinearLayoutManager(this)
        layoutManager.orientation = LinearLayoutManager.HORIZONTAL
        var onSceneSelectedArrayList = ArrayList<View.OnClickListener>()
        for (i in 0 until resourceThemeBitmap.size + 1) {
            if(i == 0){
                onSceneSelectedArrayList.add(View.OnClickListener {
                    val intent = Intent()
                    intent.type = "image/*"
                    intent.action = Intent.ACTION_GET_CONTENT
                    startActivityForResult(intent, FROM_GALLERY_AND_CROP)
                })
            }
            else {onSceneSelectedArrayList.add(replaceScene(i - 1))}
        }
        var replaceData = ArrayList<String>().apply {
            add(File(Config.ASSETS_FOLDER, Config.PROJECT_WHITE_FILE_NAME).path)
            addAll(resourceThemeBitmap)
        }
        var addSceneAdapter = AddSceneAdapter(this, replaceData, onSceneSelectedArrayList)
        var newSceneRecyclerView = addSceneView.findViewById<RecyclerView>(R.id.new_scene_recycler_view)
        newSceneRecyclerView.layoutManager = layoutManager
        newSceneRecyclerView.adapter = addSceneAdapter
        addSceneView.btn_add_scene_view_character.setOnClickListener {
            viewContainer.removeAllViews()
            initActorRecyclerView()
        }
        addSceneView.btn_add_scene_view_object.setOnClickListener {
            initAddObjectView()
        }
        addSceneView.btn_replace_scene_view_choose_theme.text = themeName
        addSceneView.btn_replace_scene_view_choose_theme.setOnClickListener {
            chooseTheme()
        }
    }

    private fun initAddObjectView(){
        viewContainer.removeAllViews()
        switchLayer(0)
        var objectView = ObjectView(this)
        objectView.setData(resourceObjectPath)
        sceneEditView.findViewById<LayerView>(currentLayerIndex).setOnDragListener(objectDragListener())
        viewContainer.addView(objectView)
        objectView.layoutParams.width = monitorSize.widthPixels
        objectView.btn_character.setOnClickListener {
            viewContainer.removeAllViews()
            initActorRecyclerView()
        }
        objectView.btn_scene.setOnClickListener {
            initReplaceSceneView()
        }
        objectView.btn_choose_theme.text = themeName
        objectView.btn_choose_theme.setOnClickListener {
            chooseTheme()
        }
    }
    private fun switchScene(position: Int): View.OnClickListener {
        return View.OnClickListener {
            var oldSceneIndex = currentSceneIndex
            currentSceneIndex = position
            switchToPreViewLayer()
            project.story?.let {
                it.scenes?.let{
                    sceneEditView.scene = it[position]
                }
            }
            record = Record()
            initControlBarView()
            initNavigationBarView(oldSceneIndex)
            initPreviousNextButton()
        }
    }

    private fun switchLayer(layerIndex: Int){
        viewContainer.removeAllViews()
        if(currentLayerIndex != 6) {
            project.story?.let {
                it.scenes?.let {
                    for (i in 0 until it[currentSceneIndex].layers[currentLayerIndex].actors.size) {
                        it[currentSceneIndex].layers[currentLayerIndex].actors[i].isSelect = false
                    }
                }
            }
        }
        currentLayerIndex = layerIndex
        controlBarView.setBtnSelected(4 - layerIndex)
        project.story?.let {
            it.scenes?.let {
                for (layer in it[currentSceneIndex].layers) {
                    when(it[currentSceneIndex].layers.indexOf(layer)) {
                        currentLayerIndex ->
                            for (actor in it[currentSceneIndex].layers[currentLayerIndex].actors) {
                                actor.isMovable = true
                            }
                        else ->
                            for (actor in it[currentSceneIndex].layers[it[currentSceneIndex].layers.indexOf(layer)].actors) {
                                actor.isMovable = false
                            }
                    }
                }

                sceneEditView.scene = it[currentSceneIndex]
            }
        }
        val sceneListener = OnTouchSceneListener()
        sceneListener.setCallBack(this)
        sceneEditView.setOnTouchListener(sceneListener)
        sceneEditView.x = 0
        setActorDropLayer()
        sceneEditView.setLayerVisible(layerIndex)
    }

    private fun switchToPreViewLayer(){
        viewContainer.removeAllViews()
        currentLayerIndex = 6
        controlBarView.setBtnSelected(currentLayerIndex)
        project.story?.let {
            it.scenes?.let {
                for (layer in it[currentSceneIndex].layers) {
                    for (actor in layer.actors) {
                        actor.isMovable = false
                        actor.isSelect = false
                    }
                }
                sceneEditView.scene = it[currentSceneIndex]
            }
        }
        val boMoSceneListener = OnTouchBoMoSceneListener()
        boMoSceneListener.setCallBack(this)
        sceneEditView.setOnTouchListener(boMoSceneListener)
        sceneEditView.x = 0
        if (viewContainer.getChildAt(0) is SelectActorView) {
            viewContainer.removeAllViews()
        }
    }


    private fun setActorDropLayer() {
        if (viewContainer.getChildAt(0) is SelectActorView) {
            var selectActorView = SelectActorView(this)
            val layoutManager = LinearLayoutManager(this)
            layoutManager.orientation = LinearLayoutManager.HORIZONTAL
            var actorAdapter = ActorAdapter(this, resourceActorBitmap, sceneEditView.findViewById(currentLayerIndex), this)
            var actorRecyclerView = selectActorView.findViewById<RecyclerView>(R.id.select_actor_recycler_view)
            actorRecyclerView.layoutManager = layoutManager
            actorRecyclerView.adapter = actorAdapter
            selectActorView.btn_object.setOnClickListener {
                viewContainer.removeAllViews()
                var objectView = ObjectView(this)
                objectView.setData(resourceObjectPath)
                sceneEditView.findViewById<LayerView>(currentLayerIndex).setOnDragListener(objectDragListener())
                viewContainer.addView(objectView)
                objectView.layoutParams.width = monitorSize.widthPixels
                objectView.btn_character.setOnClickListener {
                    viewContainer.removeAllViews()
                    initActorRecyclerView()
                }
            }
            viewContainer.addView(selectActorView)
        }
    }

    private fun onClickAddSceneListener(position: Int): View.OnClickListener {
        return View.OnClickListener {
            addScene(position)
            initControlSceneView()
            initNavigationBarView(currentSceneIndex)
        }
    }

    private fun addScene(position: Int){
        var scene = Scene()
        for (i in 5 until 0){
            val layer = Layer()
            layer.id = i
            scene.layers.add(layer)
        }
        scene.backgroundPath = resourceThemeBitmap[position]
        project.story?.let {
            it.scenes?.let{
                scene.sceneWidth = monitorSize.widthPixels
                it.add(currentSceneIndex + 1,scene)
            }
        }
    }

    private fun addCoverScene(coverPath: String){
        if (!project.isAddCoverScene) {
            var scene = Scene()
            for (i in 5 until 0) {
                val layer = Layer()
                layer.id = i
                scene.layers.add(layer)
            }
            scene.backgroundPath = coverPath
            project.story?.let {
                it.scenes?.let {
                    scene.sceneWidth = monitorSize.widthPixels
                    it.add(0, scene)
                }
            }
            project.isAddCoverScene = true
        }
    }

    private fun replaceScene(position: Int): View.OnClickListener {
        return View.OnClickListener {
            project.story?.let {
                it.scenes?.let{
                    it[currentSceneIndex].backgroundPath = resourceThemeBitmap[position]
                    sceneEditView.scene = it[currentSceneIndex]
                }
            }
        }
    }
    private fun setActorPositionZ(actors: ArrayList<Actor>){
        for (actor in actors) {
            actor.positionZ = actors.indexOf(actor)
        }
    }

    private fun pickFromGallery() {
        val intent = Intent()
        intent.type = "image/*"
        intent.action = Intent.ACTION_GET_CONTENT
        startActivityForResult(intent, PHOTO_FROM_GALLERY)
    }

    private fun addActor(positionX: Int, positionY: Int, resourcePath: String) {
        val metrics = DisplayMetrics()
        val windowManager = getSystemService(Context.WINDOW_SERVICE) as WindowManager
        windowManager.defaultDisplay.getMetrics(metrics);
        val screenWidth = metrics.widthPixels;
        val screenHeight = screenWidth / 2

        project.story?.let {
            it.scenes?.let{
                val actorData = Actor()
                actorData.sideLength = ACTOR_WIDTH
                actorData.sideHeight = ACTOR_HEIGHT
                actorData.positionX = Math.max(0, Math.min(screenWidth - actorData.sideLength, positionX))
                actorData.positionY = Math.max(0, Math.min(screenHeight - actorData.sideHeight, positionY))
                actorData.positionZ = it[currentSceneIndex].layers[currentLayerIndex].actors.size
                actorData.resourcePath = resourcePath
                actorData.parentLayerIndex = currentLayerIndex
                actorData.isMovable = true
                it[currentSceneIndex].layers[currentLayerIndex].actors.add(actorData)
                sceneEditView.scene = it[currentSceneIndex]
            }
        }
        viewContainer.removeAllViews()
        startRecord.visibility = View.VISIBLE
        sceneEditView.setLayerVisible(currentLayerIndex)
    }

    private fun addBrushView(positionX: Int, positionY: Int, resourcePath: String) {
        val metrics = DisplayMetrics()
        val windowManager = getSystemService(Context.WINDOW_SERVICE) as WindowManager
        windowManager.defaultDisplay.getMetrics(metrics);
        val screenWidth = metrics.widthPixels;
        val screenHeight = screenWidth / 2

        project.story?.let {
            it.scenes?.let{
                val actorData = Actor()
                actorData.sideLength = BitmapFactory.decodeFile(resourcePath).width + (resources.getDimension(R.dimen.actor_padding_for_edit).toInt() * 2)
                actorData.sideHeight = BitmapFactory.decodeFile(resourcePath).height + (resources.getDimension(R.dimen.actor_padding_for_edit).toInt() * 2)
                actorData.positionX = positionX - resources.getDimension(R.dimen.actor_padding_for_edit).toInt()
                actorData.positionY = positionY - resources.getDimension(R.dimen.actor_padding_for_edit).toInt()
                actorData.positionZ = it[currentSceneIndex].layers[currentLayerIndex].actors.size
                actorData.resourcePath = resourcePath
                actorData.parentLayerIndex = currentLayerIndex
                actorData.isMovable = true
                it[currentSceneIndex].layers[currentLayerIndex].actors.add(actorData)
                sceneEditView.scene = it[currentSceneIndex]
            }
        }
        viewContainer.removeAllViews()
        startRecord.visibility = View.VISIBLE
        sceneEditView.setLayerVisible(currentLayerIndex)
    }

    private fun addObject(positionX: Int, positionY: Int, resourcePath: String) {
        val metrics = DisplayMetrics()
        val windowManager = getSystemService(Context.WINDOW_SERVICE) as WindowManager
        windowManager.defaultDisplay.getMetrics(metrics);
        val screenWidth = metrics.widthPixels;
        val screenHeight = screenWidth / 2

        project.story?.let {
            it.scenes?.let{
                val actorData = Actor()
                actorData.sideLength = ACTOR_WIDTH
                actorData.sideHeight = ACTOR_HEIGHT
                actorData.positionX = Math.max(0, Math.min(screenWidth - actorData.sideLength, positionX))
                actorData.positionY = Math.max(0, Math.min(screenHeight - actorData.sideHeight, positionY))
                actorData.positionZ = it[currentSceneIndex].layers[currentLayerIndex].actors.size
                actorData.resourcePath = resourcePath
                actorData.parentLayerIndex = currentLayerIndex
                actorData.isMovable = true
                it[currentSceneIndex].layers[currentLayerIndex].actors.add(actorData)
                sceneEditView.scene = it[currentSceneIndex]
            }
        }
        sceneEditView.setLayerVisible(currentLayerIndex)
        startRecord.visibility = View.VISIBLE
        viewContainer.removeAllViews()
    }
    private fun addDialogue(positionX: Int, positionY: Int, resource: Int) {
        val metrics = DisplayMetrics()
        val windowManager = getSystemService(Context.WINDOW_SERVICE) as WindowManager
        windowManager.defaultDisplay.getMetrics(metrics);
        val screenWidth = metrics.widthPixels;
        val screenHeight = screenWidth / 2

        project.story?.let {
            it.scenes?.let{
                val dialog = Actor()
                dialog.sideLength = DIALOGUE_WIDTH
                dialog.sideHeight = DIALOGUE_HEIGHT
                dialog.resourcePath = resource.toString()
                dialog.positionX = Math.max(0, Math.min(screenWidth - dialog.sideLength, positionX))
                dialog.positionY = Math.max(0, Math.min(screenHeight - dialog.sideHeight, positionY))
                dialog.positionZ = it[currentSceneIndex].layers[currentLayerIndex].actors.size
                dialog.parentLayerIndex = currentLayerIndex
                dialog.isMovable = true
                dialog.isDialogue = true
                dialog.dialogType = DialogueColorData.getDialogColorType(resource).first
                dialog.dialogColor = DialogueColorData.getDialogColorType(resource).second
                it[currentSceneIndex].layers[currentLayerIndex].actors.add(dialog)
                sceneEditView.scene = it[currentSceneIndex]
                editTextDialog = EditTextDialog()
                editTextDialog.setCallBack(this)
                editTextDialog.setDialogue(dialog)
                editTextDialog.show(supportFragmentManager,LAYER_MANAGEMENT)
            }
        }
        sceneEditView.setLayerVisible(currentLayerIndex)
        viewContainer.removeAllViews()
    }
    override fun onActorDropFinish(positionX: Int, positionY: Int, resourcePath: String) {
        addActor(positionX, positionY, resourcePath)
    }

    override fun onActorChange(actor: Actor) {
        project.story?.let {
            it.scenes?.let {
                it[currentSceneIndex].layers[currentLayerIndex].actors[actor.positionZ] = actor
            }
        }
        sceneEditView.setLayerVisible(currentLayerIndex)
    }

    override fun onActorSelected(actor: Actor) {
        project.story?.let {
            it.scenes?.let {
                for(i in 0 until it[currentSceneIndex].layers[currentLayerIndex].actors.size){
                    if(actor.positionZ == i) {
                        it[currentSceneIndex].layers[currentLayerIndex].actors[i].isSelect =
                                !it[currentSceneIndex].layers[currentLayerIndex].actors[i].isSelect
                    } else {
                        it[currentSceneIndex].layers[currentLayerIndex].actors[i].isSelect = false
                    }
                }
                sceneEditView.scene = it[currentSceneIndex]
            }
        }
        sceneEditView.setLayerVisible(currentLayerIndex)
    }

    override fun onActorLongClick(actor: Actor) {
        project.story?.let {
            it.scenes?.let {
                for(i in 0 until it[currentSceneIndex].layers[currentLayerIndex].actors.size){
                    if(actor.positionZ == i) {
                        it[currentSceneIndex].layers[currentLayerIndex].actors[i].isSelect =
                                !it[currentSceneIndex].layers[currentLayerIndex].actors[i].isSelect
                    } else {
                        it[currentSceneIndex].layers[currentLayerIndex].actors[i].isSelect = false
                    }
                }
                sceneEditView.scene = it[currentSceneIndex]
            }
        }
        sceneEditView.setLayerVisible(currentLayerIndex)
        var popupWindow = PopupWindow(this)
        popupWindow.contentView = when(actor.isDialogue) { true -> createDialogPopupView(actor, popupWindow)
                                                           false -> createActorPopupView(actor, popupWindow)}
        popupWindow.width = ViewGroup.LayoutParams.WRAP_CONTENT
        popupWindow.height = ViewGroup.LayoutParams.WRAP_CONTENT
        popupWindow.isOutsideTouchable = true
        popupWindow.showAtLocation(sceneEditView, Gravity.START,actor.positionX,actor.positionY)
    }

    private fun createActorPopupView(actor: Actor, popupWindow: PopupWindow): View{
        val popupView = LayoutInflater.from(this).inflate(R.layout.control_actor_dialog, null)
        popupView.duplicate.setOnClickListener{
            project.story?.let {
                it.scenes?.let {
                    val actorData = Actor().apply {
                        positionX = actor.positionX + 100
                        positionY = actor.positionY + 100
                        positionZ = it[currentSceneIndex].layers[currentLayerIndex].actors.size
                        sideLength = actor.sideLength
                        sideHeight = actor.sideHeight
                        resourcePath = actor.resourcePath
                        parentLayerIndex = currentLayerIndex
                        isMovable = true
                        opacity = actor.opacity
                        isMirror = actor.isMirror
                        dialogType = actor.dialogType
                        dialogColor = actor.dialogColor
                        hue = actor.hue
                        brightness = actor.brightness
                        saturation = actor.saturation
                    }
                    it[currentSceneIndex].layers[currentLayerIndex].actors.add(actorData)
                    setActorPositionZ(it[currentSceneIndex].layers[currentLayerIndex].actors)
                    sceneEditView.scene = it[currentSceneIndex]
                    popupWindow.dismiss()
                }
            }
            sceneEditView.setLayerVisible(currentLayerIndex)
        }
        popupView.opacity.setOnClickListener {
            popupWindow.dismiss()
            var popupWindow = PopupWindow(this)
            var popupView = LayoutInflater.from(this).inflate(R.layout.popupview_opacity_dialog, null)
            popupWindow.contentView = popupView
            popupWindow.width = ViewGroup.LayoutParams.WRAP_CONTENT
            popupWindow.height = ViewGroup.LayoutParams.WRAP_CONTENT
            popupWindow.isOutsideTouchable = false
            popupWindow.showAtLocation(sceneEditView, Gravity.START,actor.positionX,0)
            popupView.sb_opacity_dialog_opacity.progress = (actor.opacity * 100).toInt()
            popupView.tv_opacity_dialog_opacity.text = resources.getString(R.string.uikit_edit_opacity) + " : " + (actor.opacity * 100).toInt().toString() + "%"
            popupView.sb_opacity_dialog_opacity.setOnSeekBarChangeListener(object : SeekBar.OnSeekBarChangeListener{
                override fun onProgressChanged(p0: SeekBar?, p1: Int, p2: Boolean) {
                    popupView.tv_opacity_dialog_opacity.text = "Opacity : " + p1.toString() + "%"
                    project.story?.let {
                        it.scenes?.let {
                            it[currentSceneIndex].layers[currentLayerIndex].actors[actor.positionZ].opacity = p1.toFloat()
                            sceneEditView.scene = it[currentSceneIndex]
                            sceneEditView.setLayerVisible(currentLayerIndex)
                        }
                    }
                }
                override fun onStartTrackingTouch(p0: SeekBar?) {
                }
                override fun onStopTrackingTouch(p0: SeekBar?) {
                }
            })
            popupView.tv_opacity_dialog_ok.setOnClickListener {
                popupWindow.dismiss()
                sceneEditView.setLayerVisible(currentLayerIndex)
            }
            sceneEditView.setLayerVisible(currentLayerIndex)
        }
        popupView.adjustment.setOnClickListener {
            popupWindow.dismiss()
            var popupWindow = PopupWindow(this)
            var popupView = LayoutInflater.from(this).inflate(R.layout.popupview_adjustment_dialog, null)
            popupWindow.contentView = popupView
            popupWindow.width = ViewGroup.LayoutParams.WRAP_CONTENT
            popupWindow.height = ViewGroup.LayoutParams.WRAP_CONTENT
            popupWindow.isOutsideTouchable = false
            popupWindow.showAtLocation(sceneEditView, Gravity.START,actor.positionX,0)
            popupView.sb_adjustment_dialog_hue.progress = actor.hue.toInt() + 180
            popupView.tv_adjustment_dialog_hue.text = "Hue" + " : " + (actor.hue.toInt() + 180).toString()
            popupView.sb_adjustment_dialog_hue.setOnSeekBarChangeListener(object : SeekBar.OnSeekBarChangeListener{
                override fun onProgressChanged(p0: SeekBar?, p1: Int, p2: Boolean) {
                    popupView.tv_adjustment_dialog_hue.text = "Hue : " + p1.toString()
                    project.story?.let {
                        it.scenes?.let {
                            it[currentSceneIndex].layers[currentLayerIndex].actors[actor.positionZ].hue = p1.toFloat() - 180
                            sceneEditView.scene = it[currentSceneIndex]
                            sceneEditView.setLayerVisible(currentLayerIndex)
                        }
                    }
                }
                override fun onStartTrackingTouch(p0: SeekBar?) {
                }
                override fun onStopTrackingTouch(p0: SeekBar?) {
                }
            })
            popupView.tv_adjustment_dialog_done.setOnClickListener {
                popupWindow.dismiss()
                sceneEditView.setLayerVisible(currentLayerIndex)
            }
            popupView.sb_adjustment_dialog_brightness.progress = actor.brightness.toInt()
            popupView.tv_adjustment_dialog_brightness.text = "Brightness" + " : " + actor.brightness.toInt().toString()
            popupView.sb_adjustment_dialog_brightness.setOnSeekBarChangeListener(object : SeekBar.OnSeekBarChangeListener{
                override fun onProgressChanged(p0: SeekBar?, p1: Int, p2: Boolean) {
                    popupView.tv_adjustment_dialog_brightness.text = "Brightness : " + p1.toString()
                    project.story?.let {
                        it.scenes?.let {
                            it[currentSceneIndex].layers[currentLayerIndex].actors[actor.positionZ].brightness = p1.toFloat()
                            sceneEditView.scene = it[currentSceneIndex]
                            sceneEditView.setLayerVisible(currentLayerIndex)
                        }
                    }
                }
                override fun onStartTrackingTouch(p0: SeekBar?) {
                }
                override fun onStopTrackingTouch(p0: SeekBar?) {
                }
            })
            popupView.sb_adjustment_dialog_saturation.progress = actor.saturation.toInt()
            popupView.tv_adjustment_dialog_saturation.text = "Saturation" + " : " + actor.saturation.toInt().toString()
            popupView.sb_adjustment_dialog_saturation.setOnSeekBarChangeListener(object : SeekBar.OnSeekBarChangeListener{
                override fun onProgressChanged(p0: SeekBar?, p1: Int, p2: Boolean) {
                    popupView.tv_adjustment_dialog_saturation.text = "Saturation : " + p1.toString()
                    project.story?.let {
                        it.scenes?.let {
                            it[currentSceneIndex].layers[currentLayerIndex].actors[actor.positionZ].saturation = p1.toFloat()
                            sceneEditView.scene = it[currentSceneIndex]
                            sceneEditView.setLayerVisible(currentLayerIndex)
                        }
                    }
                }
                override fun onStartTrackingTouch(p0: SeekBar?) {
                }
                override fun onStopTrackingTouch(p0: SeekBar?) {
                }
            })
            sceneEditView.setLayerVisible(currentLayerIndex)
        }
        popupView.Mirror.setOnClickListener {
            project.story?.let {
                it.scenes?.let {
                    it[currentSceneIndex].layers[currentLayerIndex].actors[actor.positionZ].isMirror =
                            !it[currentSceneIndex].layers[currentLayerIndex].actors[actor.positionZ].isMirror
                    sceneEditView.scene = it[currentSceneIndex]
                    popupWindow.dismiss()
                }
            }
            sceneEditView.setLayerVisible(currentLayerIndex)
        }
        popupView.bring_to_front.setOnClickListener{
            project.story?.let {
                it.scenes?.let {
                    if(actor.positionZ + 1 < it[currentSceneIndex].layers[currentLayerIndex].actors.size) {
                        it[currentSceneIndex].layers[currentLayerIndex].actors.removeAt(actor.positionZ)
                        it[currentSceneIndex].layers[currentLayerIndex].actors.add(actor.positionZ + 1, actor)
                    }
                    setActorPositionZ(it[currentSceneIndex].layers[currentLayerIndex].actors)
                    sceneEditView.scene = it[currentSceneIndex]
                    popupWindow.dismiss()
                }
            }
            sceneEditView.setLayerVisible(currentLayerIndex)
        }
        popupView.send_to_back.setOnClickListener{
            project.story?.let {
                it.scenes?.let {
                    if(actor.positionZ - 1 >= 0) {
                        it[currentSceneIndex].layers[currentLayerIndex].actors.removeAt(actor.positionZ)
                        it[currentSceneIndex].layers[currentLayerIndex].actors.add(actor.positionZ - 1, actor)
                    }
                    setActorPositionZ(it[currentSceneIndex].layers[currentLayerIndex].actors)
                    sceneEditView.scene = it[currentSceneIndex]
                    popupWindow.dismiss()
                }
            }
            sceneEditView.setLayerVisible(currentLayerIndex)
        }
        popupView.delete.setOnClickListener{
            project.story?.let {
                it.scenes?.let {
                    it[currentSceneIndex].layers[currentLayerIndex].actors.removeAt(actor.positionZ)
                    setActorPositionZ(it[currentSceneIndex].layers[currentLayerIndex].actors)
                    sceneEditView.scene = it[currentSceneIndex]
                    popupWindow.dismiss()
                }
            }
            sceneEditView.setLayerVisible(currentLayerIndex)
        }
        return popupView
    }

    private fun createDialogPopupView(actor: Actor, popupWindow: PopupWindow): View{
        val popupView = LayoutInflater.from(this).inflate(R.layout.view_control_dialogue_dialog, null)
        popupView.edit_content_dialogue.setOnClickListener{
            project.story?.let {
                it.scenes?.let {
                    editTextDialog = EditTextDialog()
                    editTextDialog.setCallBack(this)
                    editTextDialog.setDialogue(actor)
                    editTextDialog.show(supportFragmentManager,LAYER_MANAGEMENT)
                    popupWindow.dismiss()
                }
            }
            sceneEditView.setLayerVisible(currentLayerIndex)
        }
        popupView.duplicate_dialogue.setOnClickListener{
            project.story?.let {
                it.scenes?.let {
                    val actorData = Actor().apply {
                        positionX = actor.positionX + 100
                        positionY = actor.positionY + 100
                        positionZ = it[currentSceneIndex].layers[currentLayerIndex].actors.size
                        sideLength = actor.sideLength
                        sideHeight = actor.sideHeight
                        resourcePath = actor.resourcePath
                        parentLayerIndex = currentLayerIndex
                        isMovable = true
                        text = actor.text
                        textColor = actor.textColor
                        textAlign =  actor.textAlign
                        isDialogue = actor.isDialogue
                        opacity = actor.opacity
                        isMirror = actor.isMirror
                        dialogType = actor.dialogType
                        dialogColor = actor.dialogColor
                    }
                    it[currentSceneIndex].layers[currentLayerIndex].actors.add(actorData)
                    setActorPositionZ(it[currentSceneIndex].layers[currentLayerIndex].actors)
                    sceneEditView.scene = it[currentSceneIndex]
                    popupWindow.dismiss()
                }
            }
            sceneEditView.setLayerVisible(currentLayerIndex)
        }
        popupView.Mirror_dialogue.setOnClickListener {
            project.story?.let {
                it.scenes?.let {
                    it[currentSceneIndex].layers[currentLayerIndex].actors[actor.positionZ].isMirror =
                            !it[currentSceneIndex].layers[currentLayerIndex].actors[actor.positionZ].isMirror
                    sceneEditView.scene = it[currentSceneIndex]
                    popupWindow.dismiss()
                }
            }
            sceneEditView.setLayerVisible(currentLayerIndex)
        }
        popupView.layout_dialogue_dialog_color.setOnClickListener {
            popupWindow.dismiss()
            var popupWindow = PopupWindow(this)
            var popupView = LayoutInflater.from(this).inflate(R.layout.popupview_color_dialog, null)
            when (actor.dialogColor){
                0 -> popupView.iv_dialogue_set_color_white.setImageResource(R.drawable.ic_done)
                1 -> popupView.iv_dialogue_set_color_yellow.setImageResource(R.drawable.ic_done)
                2 -> popupView.iv_dialogue_set_color_blue.setImageResource(R.drawable.ic_done)
                3 -> popupView.iv_dialogue_set_color_green.setImageResource(R.drawable.ic_done)
                4 -> popupView.iv_dialogue_set_color_orange.setImageResource(R.drawable.ic_done)
            }
            popupView.iv_dialogue_set_color_white.setOnClickListener {
                popupView.iv_dialogue_set_color_white.setImageResource(R.drawable.ic_done)
                popupView.iv_dialogue_set_color_blue.setImageDrawable(null)
                popupView.iv_dialogue_set_color_yellow.setImageDrawable(null)
                popupView.iv_dialogue_set_color_green.setImageDrawable(null)
                popupView.iv_dialogue_set_color_orange.setImageDrawable(null)
                project.story?.let {
                    it.scenes?.let {
                        it[currentSceneIndex].layers[currentLayerIndex].actors[actor.positionZ].resourcePath = DialogueColorData.dialogMap[Pair(actor.dialogType,0)].toString()
                        it[currentSceneIndex].layers[currentLayerIndex].actors[actor.positionZ].dialogColor = 0

                        sceneEditView.scene = it[currentSceneIndex]
                    }
                }
            }
            popupView.iv_dialogue_set_color_blue.setOnClickListener {
                popupView.iv_dialogue_set_color_white.setImageDrawable(null)
                popupView.iv_dialogue_set_color_blue.setImageResource(R.drawable.ic_done)
                popupView.iv_dialogue_set_color_yellow.setImageDrawable(null)
                popupView.iv_dialogue_set_color_green.setImageDrawable(null)
                popupView.iv_dialogue_set_color_orange.setImageDrawable(null)
                project.story?.let {
                    it.scenes?.let {
                        it[currentSceneIndex].layers[currentLayerIndex].actors[actor.positionZ].resourcePath = DialogueColorData.dialogMap[Pair(actor.dialogType,2)].toString()
                        it[currentSceneIndex].layers[currentLayerIndex].actors[actor.positionZ].dialogColor = 2
                        sceneEditView.scene = it[currentSceneIndex]
                    }
                }
            }
            popupView.iv_dialogue_set_color_yellow.setOnClickListener {
                popupView.iv_dialogue_set_color_white.setImageDrawable(null)
                popupView.iv_dialogue_set_color_blue.setImageDrawable(null)
                popupView.iv_dialogue_set_color_yellow.setImageResource(R.drawable.ic_done)
                popupView.iv_dialogue_set_color_green.setImageDrawable(null)
                popupView.iv_dialogue_set_color_orange.setImageDrawable(null)
                project.story?.let {
                    it.scenes?.let {
                        it[currentSceneIndex].layers[currentLayerIndex].actors[actor.positionZ].resourcePath = DialogueColorData.dialogMap[Pair(actor.dialogType,1)].toString()
                        it[currentSceneIndex].layers[currentLayerIndex].actors[actor.positionZ].dialogColor = 1
                        sceneEditView.scene = it[currentSceneIndex]
                    }
                }
                sceneEditView.setLayerVisible(currentLayerIndex)
            }
            popupView.iv_dialogue_set_color_green.setOnClickListener {
                popupView.iv_dialogue_set_color_white.setImageDrawable(null)
                popupView.iv_dialogue_set_color_blue.setImageDrawable(null)
                popupView.iv_dialogue_set_color_yellow.setImageDrawable(null)
                popupView.iv_dialogue_set_color_green.setImageResource(R.drawable.ic_done)
                popupView.iv_dialogue_set_color_orange.setImageDrawable(null)
                project.story?.let {
                    it.scenes?.let {
                        it[currentSceneIndex].layers[currentLayerIndex].actors[actor.positionZ].resourcePath = DialogueColorData.dialogMap[Pair(actor.dialogType,3)].toString()
                        it[currentSceneIndex].layers[currentLayerIndex].actors[actor.positionZ].dialogColor = 3
                        sceneEditView.scene = it[currentSceneIndex]
                    }
                }
                sceneEditView.setLayerVisible(currentLayerIndex)
            }
            popupView.iv_dialogue_set_color_orange.setOnClickListener {
                popupView.iv_dialogue_set_color_white.setImageDrawable(null)
                popupView.iv_dialogue_set_color_blue.setImageDrawable(null)
                popupView.iv_dialogue_set_color_yellow.setImageDrawable(null)
                popupView.iv_dialogue_set_color_green.setImageDrawable(null)
                popupView.iv_dialogue_set_color_orange.setImageResource(R.drawable.ic_done)
                project.story?.let {
                    it.scenes?.let {
                        it[currentSceneIndex].layers[currentLayerIndex].actors[actor.positionZ].resourcePath = DialogueColorData.dialogMap[Pair(actor.dialogType,4)].toString()
                        it[currentSceneIndex].layers[currentLayerIndex].actors[actor.positionZ].dialogColor = 4
                        sceneEditView.scene = it[currentSceneIndex]
                    }
                }
                sceneEditView.setLayerVisible(currentLayerIndex)
            }
            popupView.tv_color_dialog_ok.setOnClickListener {
                popupWindow.dismiss()
                sceneEditView.setLayerVisible(currentLayerIndex)
            }
            popupWindow.width = ViewGroup.LayoutParams.WRAP_CONTENT
            popupWindow.height = ViewGroup.LayoutParams.WRAP_CONTENT
            popupWindow.contentView = popupView
            popupWindow.isOutsideTouchable = false
            popupWindow.showAtLocation(sceneEditView, Gravity.START,actor.positionX,0)
            sceneEditView.setLayerVisible(currentLayerIndex)
        }
        popupView.bring_to_front_dialogue.setOnClickListener{
            project.story?.let {
                it.scenes?.let {
                    it[currentSceneIndex].layers[currentLayerIndex].actors.remove(actor)
                    it[currentSceneIndex].layers[currentLayerIndex].actors.add(actor)
                    setActorPositionZ(it[currentSceneIndex].layers[currentLayerIndex].actors)
                    sceneEditView.scene = it[currentSceneIndex]
                    popupWindow.dismiss()
                }
            }
            sceneEditView.setLayerVisible(currentLayerIndex)
        }
        popupView.send_to_back_dialogue.setOnClickListener{
            project.story?.let {
                it.scenes?.let {
                    it[currentSceneIndex].layers[currentLayerIndex].actors.remove(actor)
                    it[currentSceneIndex].layers[currentLayerIndex].actors.add(0, actor)
                    setActorPositionZ(it[currentSceneIndex].layers[currentLayerIndex].actors)
                    sceneEditView.scene = it[currentSceneIndex]
                    popupWindow.dismiss()
                }
            }
            sceneEditView.setLayerVisible(currentLayerIndex)
        }
        popupView.delete_dialogue.setOnClickListener{
            project.story?.let {
                it.scenes?.let {
                    it[currentSceneIndex].layers[currentLayerIndex].actors.removeAt(actor.positionZ)
                    setActorPositionZ(it[currentSceneIndex].layers[currentLayerIndex].actors)
                    sceneEditView.scene = it[currentSceneIndex]
                    popupWindow.dismiss()
                }
            }
            sceneEditView.setLayerVisible(currentLayerIndex)
        }
        return popupView
    }

    private fun createBackGroundPopupView(popupWindow: PopupWindow): View{
        val popupView = LayoutInflater.from(this).inflate(R.layout.control_background_dialog, null)

        popupView.adjustment.setOnClickListener {
            popupWindow.dismiss()
            var popupWindow = PopupWindow(this)
            var popupView = LayoutInflater.from(this).inflate(R.layout.popupview_adjustment_dialog, null)
            popupWindow.contentView = popupView
            popupWindow.width = ViewGroup.LayoutParams.WRAP_CONTENT
            popupWindow.height = ViewGroup.LayoutParams.WRAP_CONTENT
            popupWindow.isOutsideTouchable = false
            popupWindow.showAtLocation(sceneEditView, Gravity.CENTER,0,0)
            project.story?.let {
                it.scenes?.let {
                    popupView.sb_adjustment_dialog_hue.progress = it[currentSceneIndex].hue.toInt() + 180
                    popupView.tv_adjustment_dialog_hue.text = "Hue" + " : " + (it[currentSceneIndex].hue.toInt() + 180).toString()
                    popupView.sb_adjustment_dialog_hue.setOnSeekBarChangeListener(object : SeekBar.OnSeekBarChangeListener{
                        override fun onProgressChanged(p0: SeekBar?, p1: Int, p2: Boolean) {
                            popupView.tv_adjustment_dialog_hue.text = "Hue : " + p1.toString()
                            project.story?.let {
                                it.scenes?.let {
                                    it[currentSceneIndex].hue = p1.toFloat() - 180
                                    sceneEditView.scene = it[currentSceneIndex]
                                    sceneEditView.setLayerVisible(currentLayerIndex)
                                }
                            }
                        }
                        override fun onStartTrackingTouch(p0: SeekBar?) {
                        }
                        override fun onStopTrackingTouch(p0: SeekBar?) {
                        }
                    })
                }
            }
            popupView.tv_adjustment_dialog_done.setOnClickListener {
                popupWindow.dismiss()
                sceneEditView.setLayerVisible(currentLayerIndex)
            }
            project.story?.let {
                it.scenes?.let {
                    popupView.sb_adjustment_dialog_brightness.progress = it[currentSceneIndex].brightness.toInt()
                    popupView.tv_adjustment_dialog_brightness.text = "Brightness" + " : " + it[currentSceneIndex].brightness.toInt().toString()
                    popupView.sb_adjustment_dialog_brightness.setOnSeekBarChangeListener(object : SeekBar.OnSeekBarChangeListener {
                        override fun onProgressChanged(p0: SeekBar?, p1: Int, p2: Boolean) {
                            popupView.tv_adjustment_dialog_brightness.text = "Brightness : " + p1.toString()
                            project.story?.let {
                                it.scenes?.let {
                                    it[currentSceneIndex].brightness = p1.toFloat()
                                    sceneEditView.scene = it[currentSceneIndex]
                                    sceneEditView.setLayerVisible(currentLayerIndex)
                                }
                            }
                        }

                        override fun onStartTrackingTouch(p0: SeekBar?) {
                        }

                        override fun onStopTrackingTouch(p0: SeekBar?) {
                        }
                    })
                }
            }
            project.story?.let {
                it.scenes?.let {
                    popupView.sb_adjustment_dialog_saturation.progress = it[currentSceneIndex].saturation.toInt()
                    popupView.tv_adjustment_dialog_saturation.text = "Saturation" + " : " + it[currentSceneIndex].saturation.toInt().toString()
                    popupView.sb_adjustment_dialog_saturation.setOnSeekBarChangeListener(object : SeekBar.OnSeekBarChangeListener {
                        override fun onProgressChanged(p0: SeekBar?, p1: Int, p2: Boolean) {
                            popupView.tv_adjustment_dialog_saturation.text = "Saturation : " + p1.toString()
                            project.story?.let {
                                it.scenes?.let {
                                    it[currentSceneIndex].saturation = p1.toFloat()
                                    sceneEditView.scene = it[currentSceneIndex]
                                    sceneEditView.setLayerVisible(currentLayerIndex)
                                }
                            }
                        }

                        override fun onStartTrackingTouch(p0: SeekBar?) {
                        }

                        override fun onStopTrackingTouch(p0: SeekBar?) {
                        }
                    })
                }
            }
            sceneEditView.setLayerVisible(currentLayerIndex)
        }
        popupView.Mirror.setOnClickListener {
            project.story?.let {
                it.scenes?.let {
                    it[currentSceneIndex].isBackGroundMirror = !it[currentSceneIndex].isBackGroundMirror
                    sceneEditView.scene = it[currentSceneIndex]
                    popupWindow.dismiss()
                }
            }
            sceneEditView.setLayerVisible(currentLayerIndex)
        }

        return popupView
    }

    override fun onSceneMove(dX: Int) {
        if ( (BACKGROUND_MOVE_RATE * monitorSize.widthPixels.div(BACKGROUND_MOVE_RATE * 4)) >= (swipeX + dX) && (swipeX + dX) > (-(BACKGROUND_MOVE_RATE * monitorSize.widthPixels.div(BACKGROUND_MOVE_RATE * 4)))) {
            sceneEditView.x = swipeX + dX
            if (isRecord) {
                record?.tracks.let {
                    val track = Track()
                    track.positionX = swipeX + dX
                    track.time = System.currentTimeMillis() - startRecordTime
                    record.tracks.add(track)
                }
            }
        }
    }

    override fun onSceneReadyToMove() {
        swipeX = sceneEditView.x
    }

    override fun onSceneFinishMove() {
        swipeX = 0
    }

    override fun onDismiss(dialog: DialogInterface?) {
        project.story?.let {
            it.scenes?.let {
                sceneEditView.scene = it[currentSceneIndex]
            }
        }
        window.decorView.apply {
            systemUiVisibility = (View.SYSTEM_UI_FLAG_LAYOUT_STABLE
                    or View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION
                    or View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN
                    or View.SYSTEM_UI_FLAG_HIDE_NAVIGATION
                    or View.SYSTEM_UI_FLAG_FULLSCREEN
                    or View.SYSTEM_UI_FLAG_LOW_PROFILE
                    or View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY)
        }
        initControlBarView()
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        when (requestCode) {
            PHOTO_FROM_GALLERY ->
                when (resultCode) {
                    Activity.RESULT_OK -> if (data != null) {
                        var uri = data.data
                        val path = FileUtils.getRealPathFromURI(this, uri)
                        if (path != null && path.endsWith(".gif"))
                            FileUtils.saveGifForActor(this, project, data.data, System.currentTimeMillis().toString())
                        else
                            FileUtils.saveImageForActor(this, project, data.data, System.currentTimeMillis().toString())
                    }
                    Activity.RESULT_CANCELED -> {
                    }
                }
            ACTOR_FROM_BRUSH -> {
                when (resultCode) {
                    Activity.RESULT_OK -> if (data != null) {
                        addBrushView(data.getIntExtra("brush_bitmap_positionX",0), data.getIntExtra("brush_bitmap_positionY",0), data.getStringExtra("brush_bitmap"))
                    }
                    Activity.RESULT_CANCELED -> {
                    }
                }
            }
            FROM_GALLERY_AND_CROP ->
                when (resultCode) {
                    Activity.RESULT_OK -> if (data != null) {
                        FileUtils.saveImageForTheme(this, project, data.data, System.currentTimeMillis().toString())
                    }
                    Activity.RESULT_CANCELED -> {
                    }
                }
            CROP_TO_BACKGROUND ->
                when (resultCode) {
                    Activity.RESULT_OK -> if (data != null) {
                        var uri = data.data
                        val path = FileUtils.getRealPathFromURI(this, uri)
                        project.story?.let {
                            it.scenes?.let{
                                it[currentSceneIndex].backgroundPath = path
                                sceneEditView.scene = it[currentSceneIndex]
                            }
                        }
                    }
                    Activity.RESULT_CANCELED -> {
                    }
                }

        }
    }

    override fun onSaveActorImage(filePath: String) {
        addActor(ACTOR_INIT_POSITION_X, ACTOR_INIT_POSITION_Y, filePath)
    }


    override fun onSaveThemeImage(filePath: String){
        val bytes = ByteArrayOutputStream()
        val bitmap = BitmapFactory.decodeFile(filePath)
        bitmap.compress(Bitmap.CompressFormat.JPEG, 100, bytes)
        val path = MediaStore.Images.Media.insertImage(contentResolver, bitmap, "Title", null)
        var uri = Uri.parse(path)
        val cropIntent = Intent("com.android.camera.action.CROP")
        cropIntent.setDataAndType(uri, "image/*")
        cropIntent.putExtra("crop", "true")
        cropIntent.putExtra("aspectX", 2)
        cropIntent.putExtra("aspectY", 1)
        cropIntent.putExtra("outputX", 128)
        cropIntent.putExtra("outputY", 128)
        cropIntent.putExtra("return-data", true)
        startActivityForResult(cropIntent, CROP_TO_BACKGROUND)
    }

    override fun onSaveCoverImage(filePath: String) {
        project.story?.let {
            it.scenes?.let {
                addCoverScene(filePath)
                sceneEditView.scene = it[0]
            }
        }
    }

    override fun onLayerChange(layerFrom: Int, layerTo: Int, position: Int){
        project.story?.let {
            it.scenes?.let {
                var actor = it[currentSceneIndex].layers[layerFrom - 1].actors[position]
                it[currentSceneIndex].layers[layerTo - 1].actors.add(actor)
                it[currentSceneIndex].layers[layerFrom - 1].actors.removeAt(position)
                layerManagementDialog.setData(it[currentSceneIndex])
                setActorPositionZ(it[currentSceneIndex].layers[layerFrom - 1].actors)
                setActorPositionZ(it[currentSceneIndex].layers[layerTo - 1].actors)
                sceneEditView.scene = it[currentSceneIndex]
            }
        }
    }

    private fun dragListener() : View.OnDragListener {
        return View.OnDragListener {v, event ->
            when (event.action) {
                DragEvent.ACTION_DRAG_STARTED -> {
                    return@OnDragListener true
                }
                DragEvent.ACTION_DROP -> {
                    addDialogue(event.x.toInt() - 100, event.y.toInt() - 100, event.clipData.getItemAt(0).text.toString().toInt())
                    return@OnDragListener true
                }
            }
            return@OnDragListener true
        }
    }

    private fun objectDragListener() : View.OnDragListener {
        return View.OnDragListener {v, event ->
            when (event.action) {
                DragEvent.ACTION_DRAG_STARTED -> {
                    return@OnDragListener true
                }
                DragEvent.ACTION_DROP -> {
                    addObject(event.x.toInt() - 100, event.y.toInt() - 100, event.clipData.getItemAt(0).text.toString())
                    return@OnDragListener true
                }
            }
            return@OnDragListener true
        }
    }

    override fun onSceneTouch(){
        unSelectActor()
        sceneEditView.setLayerVisible(currentLayerIndex)
    }

    override fun onSceneLongClick() {
        if(currentLayerIndex == 4){
            var popupWindow = PopupWindow(this)
            popupWindow.contentView = createBackGroundPopupView(popupWindow)
            popupWindow.width = ViewGroup.LayoutParams.WRAP_CONTENT
            popupWindow.height = ViewGroup.LayoutParams.WRAP_CONTENT
            popupWindow.isOutsideTouchable = true
            popupWindow.showAtLocation(sceneEditView, Gravity.CENTER,0,0)
        }
    }

    private fun unSelectActor(){
        project.story?.let {
            it.scenes?.let {
                for(i in 0 until it[currentSceneIndex].layers[currentLayerIndex].actors.size){
                    it[currentSceneIndex].layers[currentLayerIndex].actors[i].isSelect = false
                }
                sceneEditView.scene = it[currentSceneIndex]
            }
        }
    }

    override fun onLayerManagementDialog(layerNum: Int, position: Int) {
        val selectLayer = layerNum - 1
        project.story?.let {
            it.scenes?.let {
                var actor = it[currentSceneIndex].layers[selectLayer].actors[position]

        var popupWindow = PopupWindow(this)
        val popupView = LayoutInflater.from(this).inflate(R.layout.control_actor_dialog, null)
        popupView.duplicate.setOnClickListener{
            project.story?.let {
                it.scenes?.let {
                    val actorData = Actor().apply {
                        positionX = actor.positionX + 100
                        positionY = actor.positionY + 100
                        positionZ = it[currentSceneIndex].layers[selectLayer].actors.size
                        sideLength = actor.sideLength
                        sideHeight = actor.sideHeight
                        resourcePath = actor.resourcePath
                        parentLayerIndex = selectLayer
                        isMovable = true
                        opacity = actor.opacity
                        isMirror = actor.isMirror
                    }
                    it[currentSceneIndex].layers[selectLayer].actors.add(actorData)
                    setActorPositionZ(it[currentSceneIndex].layers[selectLayer].actors)
                    sceneEditView.scene = it[currentSceneIndex]
                    popupWindow.dismiss()
                    layerManagementDialog.setData(it[currentSceneIndex])
                }
            }
        }
        popupView.bring_to_front.setOnClickListener{
            project.story?.let {
                it.scenes?.let {
                    it[currentSceneIndex].layers[selectLayer].actors.remove(actor)
                    it[currentSceneIndex].layers[selectLayer].actors.add(actor)
                    setActorPositionZ(it[currentSceneIndex].layers[selectLayer].actors)
                    sceneEditView.scene = it[currentSceneIndex]
                    popupWindow.dismiss()
                    layerManagementDialog.setData(it[currentSceneIndex])
                }
            }
        }
        popupView.send_to_back.setOnClickListener{
            project.story?.let {
                it.scenes?.let {
                    it[currentSceneIndex].layers[selectLayer].actors.remove(actor)
                    it[currentSceneIndex].layers[selectLayer].actors.add(0, actor)
                    setActorPositionZ(it[currentSceneIndex].layers[selectLayer].actors)
                    sceneEditView.scene = it[currentSceneIndex]
                    popupWindow.dismiss()
                    layerManagementDialog.setData(it[currentSceneIndex])
                }
            }
        }
        popupView.delete.setOnClickListener{
            project.story?.let {
                it.scenes?.let {
                    it[currentSceneIndex].layers[selectLayer].actors.removeAt(actor.positionZ)
                    sceneEditView.scene = it[currentSceneIndex]
                    popupWindow.dismiss()
                    layerManagementDialog.setData(it[currentSceneIndex])
                }
            }
        }
        popupWindow.contentView = popupView
        popupWindow.width = ViewGroup.LayoutParams.WRAP_CONTENT
        popupWindow.height = ViewGroup.LayoutParams.WRAP_CONTENT
        popupWindow.isOutsideTouchable = true
        var valueXInPixels = resources.getDimension(R.dimen.actor_width)
        when(layerNum){
            1 -> popupWindow.showAsDropDown(layerManagementDialog.rv_layer_management_layer4, valueXInPixels.toInt() * position, 0)
            2 -> popupWindow.showAsDropDown(layerManagementDialog.rv_layer_management_layer5, valueXInPixels.toInt() * position, 0)
            3 -> popupWindow.showAsDropDown(layerManagementDialog.rv_layer_management_layer5, valueXInPixels.toInt() * position + valueXInPixels.toInt(),0)
            4 -> popupWindow.showAsDropDown(layerManagementDialog.rv_layer_management_layer4, valueXInPixels.toInt() * position, 0)
            5 -> popupWindow.showAsDropDown(layerManagementDialog.rv_layer_management_layer5, valueXInPixels.toInt() * position, 0)
        }
            }
        }
    }

    override fun onSetDialogText(dialogue: Actor, content: String) {
        project.story?.let {
            it.scenes?.let {
                if(content == "") {
                    it[currentSceneIndex].layers[currentLayerIndex].actors.remove(dialogue)
                    setActorPositionZ(it[currentSceneIndex].layers[currentLayerIndex].actors)
                    sceneEditView.scene = it[currentSceneIndex]
                } else {
                    dialogue.text = content
                    it[currentSceneIndex].layers[currentLayerIndex].actors[dialogue.positionZ] = dialogue
                    setActorPositionZ(it[currentSceneIndex].layers[currentLayerIndex].actors)
                    sceneEditView.scene = it[currentSceneIndex]
                }
                editTextDialog.dismiss()
            }
        }
    }

    override fun onEditTextDialogDismiss() {
        window.decorView.apply {
            systemUiVisibility = (View.SYSTEM_UI_FLAG_LAYOUT_STABLE
                    or View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION
                    or View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN
                    or View.SYSTEM_UI_FLAG_HIDE_NAVIGATION
                    or View.SYSTEM_UI_FLAG_FULLSCREEN
                    or View.SYSTEM_UI_FLAG_LOW_PROFILE
                    or View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY)
        }
        sceneEditView.setLayerVisible(currentLayerIndex)
        viewContainer.removeAllViews()
        startRecord.visibility = View.VISIBLE
    }

    override fun onSelectBrush(brush: Brush?) {
        brush?.let {
            paint_view.brush = it
        }
    }

    private fun chooseTheme(){
        var otherThemes =  OtherThemes()
        SuperAppModule.themeManager.themes.forEach {
            if (SuperAppModule.themeManager.canUse(it) && SuperAppModule.themeManager.isDownloaded(it)) {
                SuperAppModule.themeManager.loadThemeAssetIndex(it)
                        .subscribe { index ->
                            val data = it
                            var theme = Theme(index,SuperAppModule.themeManager.getAssetFolder(data))
                            otherThemes.themes.add(theme)
                        }
            }
        }
        val json = Gson().toJson(project)
        val themeJson = Gson().toJson(otherThemes)
        val intent = Intent(this@SceneEditActivity, ChooseThemeActivity::class.java).apply {
                         putExtra("project", json)
                         putExtra("other_theme", themeJson)
                         putExtra("currentScene",currentSceneIndex)
                         putExtra("currentLayer",currentLayerIndex)
                     }
        startActivity(intent)
        finish()
    }

    override fun onItemChange(scene: Scene) {
        project.story?.let {
            it.scenes?.let {
                for (i in 0 until 5) {
                    setActorPositionZ(it[currentSceneIndex].layers[i].actors)
                }
                sceneEditView.scene = scene
            }
        }
    }

    private fun onClickEditCover(project: Project) {
        val dialog = CoverEditorDialog()
        dialog.project = project
        dialog.onViewCreated = Runnable {
            dialog.apply {
                val oldName = project.displayName ?: ""
                onSave = View.OnClickListener { it ->
                    if (storyName == "") {
                        showEmptyProjectNameMsg()
                    } else {
                        if (coverFile == null) {
                            project.coverFile = null
                        } else {
                            project.coverFile = coverFile
                        }
                        project.displayName = storyName
                        project.author = author
                        project.frontCoverColor = frontCoverColor
                        project.backCoverColor = backCoverColor
                        project.category = category
                        val pd = ProgressDialog(this@SceneEditActivity).apply {
                            setCancelable(false)
                        }
                        FileUtils.saveProject(this@SceneEditActivity, project, 1920,1080)
                                .subscribeOn(Schedulers.io())
                                .observeOn(AndroidSchedulers.mainThread())
                                .doOnSubscribe { pd.show() }
                                .doFinally {
                                    pd.dismiss()
                                }
                                .subscribe {
                                    project.story?.let {
                                        it.scenes?.let {
                                            if (coverFile == null) {
                                                val bitmap = CoverDrawer.drawFrontCover((monitorSize.widthPixels) / 2, monitorSize.heightPixels, project.displayName
                                                        ?: "", project.author
                                                        ?: "", project.frontCoverColor.getColor(this@SceneEditActivity))
                                                val bitmap2 = CoverDrawer.drawBackCover(this@SceneEditActivity, (monitorSize.widthPixels) / 2, monitorSize.heightPixels, project.backCoverColor.getColor(this@SceneEditActivity))
                                                val bitmap3 = Bitmap.createBitmap(monitorSize.widthPixels, monitorSize.heightPixels, bitmap.config)
                                                val canvas = Canvas(bitmap3)
                                                canvas.drawBitmap(bitmap, 0f, 0f, null)
                                                canvas.drawBitmap(bitmap2, ((monitorSize.widthPixels) / 2).toFloat(), 0f, null)
                                                FileUtils.saveCover(this@SceneEditActivity, project, bitmap3, project.name.toString())
                                            } else {
                                                val bitmap = CoverDrawer.drawFrontCover((monitorSize.widthPixels) / 2, monitorSize.heightPixels, project.displayName
                                                        ?: "", project.author
                                                        ?: "", coverFile!!)
                                                val bitmap2 = CoverDrawer.drawBackCover(this@SceneEditActivity, (monitorSize.widthPixels) / 2, monitorSize.heightPixels, project.backCoverColor.getColor(this@SceneEditActivity))
                                                val bitmap3 = Bitmap.createBitmap(monitorSize.widthPixels, monitorSize.heightPixels, bitmap.config)
                                                val canvas = Canvas(bitmap3)
                                                canvas.drawBitmap(bitmap, 0f, 0f, null)
                                                canvas.drawBitmap(bitmap2, ((monitorSize.widthPixels) / 2).toFloat(), 0f, null)
                                                FileUtils.saveCover(this@SceneEditActivity, project, bitmap3, project.name.toString())
                                            }
                                        }
                                    }
                                }

                        initControlSceneView()
                        this.dismiss()
                        window.decorView.apply {
                            systemUiVisibility = (View.SYSTEM_UI_FLAG_LAYOUT_STABLE
                                    or View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION
                                    or View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN
                                    or View.SYSTEM_UI_FLAG_HIDE_NAVIGATION
                                    or View.SYSTEM_UI_FLAG_FULLSCREEN
                                    or View.SYSTEM_UI_FLAG_LOW_PROFILE
                                    or View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY)
                        }
                    }
                }
                onCancel = View.OnClickListener {
                    this.dismiss()
                    window.decorView.apply {
                        systemUiVisibility = (View.SYSTEM_UI_FLAG_LAYOUT_STABLE
                                or View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION
                                or View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN
                                or View.SYSTEM_UI_FLAG_HIDE_NAVIGATION
                                or View.SYSTEM_UI_FLAG_FULLSCREEN
                                or View.SYSTEM_UI_FLAG_LOW_PROFILE
                                or View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY)
                    }
                }
                coverFile = project.coverFile
                storyName = project.displayName ?: ""
                author = project.author ?: ""
                category = project.category
                if (project.coverFile == null) {
                    frontCoverColor = project.frontCoverColor
                }
                backCoverColor = project.backCoverColor
            }
        }
        dialog.show(supportFragmentManager)
    }

    override fun clearView() {

    }

    override fun onItemMove(fromPosition: Int, toPosition: Int) {
        project.story?.let {
            val scene = it.scenes[fromPosition]
            it.scenes.removeAt(fromPosition)
            it.scenes.add(toPosition, scene)
            when(currentSceneIndex){
                fromPosition -> {
                    currentSceneIndex = toPosition
                    sceneEditView.scene = it.scenes[toPosition]
                }
                toPosition -> {
                    currentSceneIndex = fromPosition
                    sceneEditView.scene = it.scenes[fromPosition]
                }
            }
        }
    }
}
