package com.bomostory.sceneeditmodule.screen.view

import android.view.MotionEvent
import android.view.View

class OnTouchSceneListener : View.OnTouchListener{
    var positionX = 0f
    var onSceneTouchCallBack: OnSceneTouchListener? = null
    var clickTime = 0L

    override fun onTouch(v: View?, event: MotionEvent?): Boolean {
            when (event?.action) {
                MotionEvent.ACTION_DOWN -> {
                    clickTime = System.currentTimeMillis()
                    positionX = event.x
                    onSceneTouchCallBack?.onSceneTouch()
                }
                MotionEvent.ACTION_MOVE -> {

                }
                MotionEvent.ACTION_UP -> {
                    if ((System.currentTimeMillis() - clickTime) > 1000) {
                        clickTime = 0
                        onSceneTouchCallBack?.onSceneLongClick()
                    }
                }
            }
        return true
    }

    fun setCallBack(onSceneMoveCallBack: OnSceneTouchListener){
        this.onSceneTouchCallBack = onSceneMoveCallBack
    }
    interface OnSceneTouchListener{
        fun onSceneTouch()
        fun onSceneLongClick()
    }

}
